unit TableServerOLEClass;

interface

uses
  ComObj, ActiveX, TableServer_TLB;

type
  TTableProxy = class(TAutoObject, ITableProxy)
  protected
    function Get_Active: WordBool; safecall;
    function Get_DatabaseName: WideString; safecall;
    function Get_TableData: OleVariant; safecall;
    function Get_TableName: WideString; safecall;
    procedure Close; safecall;
    procedure Open; safecall;
    procedure Set_Active(Value: WordBool); safecall;
    procedure Set_DatabaseName(const Value: WideString); safecall;
    procedure Set_TableName(const Value: WideString); safecall;
  end;

implementation

uses
  TableServerDataModule, Forms, Controls, DB, ComServ;

function TTableProxy.Get_Active: WordBool;
begin
  Result := DM.TblFrom.Active
end;

function TTableProxy.Get_DatabaseName: WideString;
begin
  Result := DM.TblFrom.DatabaseName
end;

function TTableProxy.Get_TableData: OleVariant;
var
  OuterLoop, InnerLoop: Integer;
begin
  with DM.TblFrom do
  begin
    //Make an array with one row more than the table has
    //so we can pass the field names as well
    Result := VarArrayCreate([0, FieldCount, 0, RecordCount], varOleStr);
    //Package up the field names
    for InnerLoop := 0 to FieldCount - 1 do
      Result[InnerLoop, 0] := Fields[InnerLoop].DisplayLabel;
    //Now package up the field contents
    DisableControls;
    First;
    Screen.Cursor := crHourglass;
    try
      for OuterLoop := 1 to RecordCount do
      begin
        for InnerLoop := 0 to FieldCount - 1 do
        begin
          Result[InnerLoop, OuterLoop] := Fields[InnerLoop].AsString;
          if Fields[InnerLoop] is TGraphicField then
            Result[InnerLoop, OuterLoop] := '(Graphic)'
        end;
        Next
      end
    finally
      Screen.Cursor := crDefault;
      EnableControls
    end
  end
end;

function TTableProxy.Get_TableName: WideString;
begin
  Result := DM.TblFrom.TableName
end;

procedure TTableProxy.Close;
begin
  Set_Active(False)
end;

procedure TTableProxy.Open;
begin
  Set_Active(True)
end;

procedure TTableProxy.Set_Active(Value: WordBool);
begin
  DM.TblFrom.Active := Value
end;

procedure TTableProxy.Set_DatabaseName(const Value: WideString);
begin
  DM.TblFrom.DatabaseName := Value
end;

procedure TTableProxy.Set_TableName(const Value: WideString);
begin
  DM.TblFrom.TableName := Value
end;

initialization
  TAutoObjectFactory.Create(ComServer, TTableProxy, Class_TableProxy, ciMultiInstance);
end.
