unit TableServer_TLB;

{ This file contains pascal declarations imported from a type library.
  This file will be written during each import or refresh of the type
  library editor.  Changes to this file will be discarded during the
  refresh process. }

{ TableServer Library }
{ Version 1.0 }

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

const
  LIBID_TableServer: TGUID = '{BA6C0180-4A4E-11D1-9FEB-A42B00C10000}';

const

{ Component class GUIDs }
  Class_TableProxy: TGUID = '{BA6C0182-4A4E-11D1-9FEB-A42B00C10000}';

type

{ Forward declarations: Interfaces }
  ITableProxy = interface;
  ITableProxyDisp = dispinterface;

{ Forward declarations: CoClasses }
  TableProxy = ITableProxy;

{ Dispatch interface for TableProxy Object }

  ITableProxy = interface(IDispatch)
    ['{BA6C0181-4A4E-11D1-9FEB-A42B00C10000}']
    procedure Close; safecall;
    procedure Open; safecall;
    function Get_Active: WordBool; safecall;
    procedure Set_Active(Value: WordBool); safecall;
    function Get_DatabaseName: WideString; safecall;
    procedure Set_DatabaseName(const Value: WideString); safecall;
    function Get_TableData: OleVariant; safecall;
    function Get_TableName: WideString; safecall;
    procedure Set_TableName(const Value: WideString); safecall;
    property Active: WordBool read Get_Active write Set_Active;
    property DatabaseName: WideString read Get_DatabaseName write Set_DatabaseName;
    property TableData: OleVariant read Get_TableData;
    property TableName: WideString read Get_TableName write Set_TableName;
  end;

{ DispInterface declaration for Dual Interface ITableProxy }

  ITableProxyDisp = dispinterface
    ['{BA6C0181-4A4E-11D1-9FEB-A42B00C10000}']
    procedure Close; dispid 1;
    procedure Open; dispid 2;
    property Active: WordBool dispid 3;
    property DatabaseName: WideString dispid 4;
    property TableData: OleVariant readonly dispid 0;
    property TableName: WideString dispid 6;
  end;

{ TableProxyObject }

  CoTableProxy = class
    class function Create: ITableProxy;
    class function CreateRemote(const MachineName: string): ITableProxy;
  end;



implementation

uses ComObj;

class function CoTableProxy.Create: ITableProxy;
begin
  Result := CreateComObject(Class_TableProxy) as ITableProxy;
end;

class function CoTableProxy.CreateRemote(const MachineName: string): ITableProxy;
begin
  Result := CreateRemoteComObject(MachineName, Class_TableProxy) as ITableProxy;
end;


end.
