unit ClientMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
  private
    MailSlot: Integer;
  end;

  EWin32Error = class(Exception);

var
  Form1: TForm1;

const
  MailSlotNameLocalWritePrefix = '\\.\mailslot\';
  MailSlotName = 'SampleMailslot';
  MailSlotWriteName = MailSlotNameLocalWritePrefix + MailSlotName;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  MailSlot := FileOpen(MailslotWriteName,
    fmOpenWrite or fmShareDenyWrite);
  if MailSlot = Invalid_Handle_Value then
    raise EWin32Error.Create('Cannot open client side of mailslot');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FileClose(MailSlot);
end;

procedure TForm1.Memo1Change(Sender: TObject);
var
  Msg: String;
begin
  Msg := Memo1.Text;
  if FileWrite(MailSlot, Msg[1], Length(Msg)) = HFile_Error then
    raise EWin32Error.Create('Cannot write to mailslot');
end;

end.