unit ReceiveU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { The parameter can be a TMessage, or the more }
    { convenient message records set up for each message }
    procedure WMMouseMove(var Msg: TWMMouseMove);
      message wm_MouseMove;
    { This implements the form's window procedure }
    procedure WndProc(var Msg: TMessage); override;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WMMouseMove(var Msg: TWMMouseMove);
begin
  Label1.Caption := Format(
    'The specific message handler sees the mouse at (%d, %d)',
    [Msg.XPos, Msg.YPos]);
  { Do whatever would normally happen }
  inherited
end;

procedure TForm1.WndProc(var Msg: TMessage);
begin
  with TWMMouseMove(Msg) do
    if Msg = wm_MouseMove then
      Label2.Caption := Format(
        'The window procedure method sees the mouse at (%d, %d)',
        [XPos, YPos]);
  { Do whatever would normally happen }
  inherited WndProc(Msg)
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  { Of course, in this particular case we can use }
  { the OnMouseMove event, but that is not the point }
  Label3.Caption := Format(
    'The OnMouseMove event handler sees the mouse at (%d, %d)',
    [X, Y]);
end;

end.
